Subject: Re: Are there any publicly known funders (companies or otherwise) of git development?

From: "Theodore Ts'o" <[email-masked]>
Date: Mon, 22 Mar 2021 07:54:17 -0400

On Fri, Mar 19, 2021 at 09:02:46PM +0000, brian m. carlson wrote:
> > 
> > Or is there any (publically known - not just an employee "randomly"
> > being told to upstream a bugfix) funded effort?
> > Such as with the Linux kernel project - where companies/organizations
> > put up money for X amount of time/efforts/projects?

There are cases where companies just "put up money", but that's
actually not all that common in the Linux kernel project.

The categorizations which Brian wrote below applies just as much to
the Linux kernel project and other major OSS projects.  Some people
are employed by some company to work 100% on a project; others work on
"20% time"; others are hobbists.

Of those work on OSS projects on corporate time, many are assigned to
a particular product (for example Android, SuSe Linux, etc.) and so
they work on features that benefit their company's product --- and
then they submit their patches to the OSS project so they don't have
to keep forward-porting features needed by their product to newer
versions of the kernel or other OSS project.  At least in the Linux
kernel world, I'd say this describes the majority of people who work
on corporate time.  And given that there are quite a few companies in
the git ecosystem (e.g., GitHub, GitLab, etc.) I suspect that's true
in the git world as well.

Cheers,

						- Ted

> There are people in the Git development community who usually work on
> Git most or full time as part of their role.  That doesn't mean those
> patches immediately make it to the list (oftentimes they are tested and
> deployed internally first), but they do generally work on Git most of
> the time and their patches do eventually show up on the list.
> 
> There are also people who work on Git with their employer's 20% time.  I
> believe we have several such contributors here in this case.
> 
> There are also people like me who usually contribute independently.  I
> have sent patches upstream that directly benefit my employer by fixing a
> direct need (in some cases written during work hours, in some cases not,
> depending on my employer at the time), but the vast majority of my work
> is independent and done on my own time.  There are others who just
> contribute independently altogether because they enjoy it.
> 
> I would say that of the top 20 contributors historically, I know that 4
> fit into the first category, 2 fit into the second category, and 3 more
> have some other corporate affiliation known to me (but not into what
> category they fall).  There are others who have more recent
> contributions who are also known to send patches on behalf of their
> employer.  I just don't know about the rest, mostly because it hasn't
> come up in context and it's never been important to me.
> 
> There are some employers that are well known to employ people in the
> first and second categories, as well as some that are known to have
> staff that send patches on behalf of their employer.
> 
> Hopefully that answers your question reasonably well, even if it's a
> little vague because I lack all the details.
> -- 
> brian m. carlson (he/him or they/them)
> Houston, Texas, US